@import "@assets/themes/themify.utils.scss";
@import "~/themes.scss";

button {
  all: unset;
  display: flex;
  justify-content: center;
  align-items: center;
  font-size: 14px;
  cursor: pointer;
  user-select: none;
  outline: none;

  &::-moz-focus-inner {
    border: 0;
  }

  &.Button-rectangle {
    width: 120px;
    height: 40px;

    & svg {
      margin: 2px;
      height: 36px;
    }
  }

  &.Button-circle {
    width: 40px;
    height: 40px;
    border-radius: 40px;

    & svg { margin: 8px; }
  }

  &.Button-square {
    width: 46px;
    height: 46px;

    & svg { margin: 8px; }
  }
}

@include themify("Button", $themes) {
  font-family: themed("font-family");

  &.Button-disabled {
    color: themed("button-disabled-label") !important;
    border: 2px solid themed("button-disabled") !important;
    background-color: themed("button-disabled") !important;

    * { fill: themed("button-disabled-label") !important; }

    cursor: not-allowed;
  }

  &.Button-primary {
    * { fill: themed("button-primary-label"); }

    &:active {
      border-color: themed("button-primary-pressed");
      background-color: themed("button-primary-pressed");
    }
  }

  &.Button-primary-outlined {
    color: themed("button-primary-outlined-label");
    border: 2px solid themed("button-primary-outlined");
    background-color: transparent;

    * { fill: themed("button-primary-outlined-label"); }

    &:hover {
      background-color: themed("button-primary-outlined-hover");
    }

    &:active {
      background-color: themed("button-primary-outlined-pressed");
    }
  }

  &.Button-secondary {
    * { fill: themed("button-secondary-label"); }

    &:active {
      background-color: themed("button-secondary-pressed");
      border-color: themed("button-secondary-pressed");
    }
  }

  &.Button-secondary-outlined {
    color: themed("button-secondary-outlined-label");
    border: 2px solid themed("button-secondary-outlined");
    background-color: transparent;

    * { fill: themed("button-secondary-outlined-label"); }

    &:hover {
      background-color: themed("button-secondary-outlined-hover");
    }

    &:active {
      background-color: themed("button-secondary-outlined-pressed");
    }
  }

  &.Button-danger {
    color: themed("button-danger-label");
    border: 2px solid themed("button-danger");
    background-color: themed("button-danger");

    * { fill: themed("button-danger-label"); }

    &:hover {
      background-color: themed("button-danger-hover");
      border-color: themed("button-danger-hover");
    }

    &:active {
      background-color: themed("button-danger-pressed");
      border-color: themed("button-danger-pressed");
    }
  }

  &.Button-danger-outlined {
    color: themed("button-danger-outlined-label");
    border: 2px solid themed("button-danger-outlined");
    background-color: transparent;

    * { fill: themed("button-danger-outlined-label"); }

    &:hover {
      background-color: themed("button-danger-outlined-hover");
    }

    &:active {
      background-color: themed("button-danger-outlined-pressed");
    }
  }

  &.Button-subtle,
  &.Button-subtle-outlined {
    color: themed("panel-text");
    border: 2px solid transparent;

    * { fill: themed("panel-icon-active"); }

    &:hover {
      color: themed("panel-text-selected");
      background-color: themed("panel-background-hover");
      border-color: themed("panel-background-hover");

      * { fill: themed("panel-text-selected"); }
    }

    &:active {
      background-color: themed("panel-background-selected");
      border-color: themed("panel-background-selected");
    }
  }

  &.Button-heavy,
  &.Button-heavy-outlined {
    color: themed("item-text");
    background-color: themed("item-background");
    border: 2px solid themed("item-background");

    * { fill: themed("item-text"); }

    &:hover {
      color: themed("item-text-selected");
      background-color: themed("item-background-hovered");
      border: 2px solid themed("item-background-hovered");

      * { fill: themed("item-text-selected"); }
    }

    &:active {
      background-color: themed("item-background-selected");
      border-color: themed("item-background-selected");
    }
  }
}
